/* Example of how to read a Snook output file in C */
/* This compiles under Turbo C++ 3.0 */

#include <stdio.h>
#include <io.h>
#include <fcntl.h>

typedef struct
  {
    float rx,ry,rz,px,py,pz,ti,ms;
    long rw,rn;
  } TSnookRec;

void main()
{
  TSnookRec R;
  long max,choice,file;
  char FName[80];
  int n;

  printf("Input name of file (e.g. 'test.snk'): ");
  scanf("%s",&FName);

  file = open(FName, O_RDONLY);
  max = filelength(file);
  printf("\nFile has %d records",max/sizeof(TSnookRec));
  printf("\nSelect a record number (0-%ld): ",max/sizeof(TSnookRec)-1);
  scanf("%ld",&choice);
  if ((choice < 0) || (choice > max-1))
    printf("That record index is invalid.");
  else
    {
      for (n = 0; n <= choice;n++)
	read(file,&R,sizeof(TSnookRec)); /* read 1 record at a time */
      printf("rx: %e  ry: %e  rz: %e  [m] \n",R.rx,R.ry,R.rz);
      printf("px: %e  py: %e  pz: %e  [kg m /s]\n",R.px,R.py,R.pz);
      printf("ms [kg]: %e  ti [s]: %e ", R.ms,R.ti);
      printf("rw: %d  rn: %d\n\n",R.rw,R.rn);
    };
  close(file);
}